#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include "AL/alc.h"
#include "AL/alut.h"
#include <windows.h>
#define	_USE_MATH_DEFINES
#include <math.h>

void AL_Init(void)
{
	ALCcontext *Context;
	ALCdevice *Device;
	ALfloat listenerPos[]={0.0,0.0,0.0};
	ALfloat listenerVel[]={0.0,0.0,0.0};
	ALfloat	listenerOri[]={0.0,0.0,-1.0, 0.0,1.0,0.0};	// Listener facing into the screen
	Device = alcOpenDevice(NULL);
	Context = alcCreateContext(Device, NULL);
	alcMakeContextCurrent(Context);
	alListenerfv(AL_POSITION, listenerPos);
	alListenerfv(AL_VELOCITY, listenerVel);
	alListenerfv(AL_ORIENTATION, listenerOri);
}

void AL_Shutdown(void)
{
	ALCdevice *Device;
	ALCcontext *Context;
	Context = alcGetCurrentContext();
	Device = alcGetContextsDevice(Context);
	alcMakeContextCurrent(NULL);
	alcDestroyContext(Context);
	alcCloseDevice(Device);
}

#define BSIZE		1024
#define NUMBUFFERS	16
#define OUTFREQ		44100

ALfloat phase = 0;
ALfloat dph =	(ALfloat)(2 * M_PI * 1000 / OUTFREQ);

void fill_buffer(ALshort *data, int nsamples)
{
	int i;
	for (i = 0; i < nsamples; i++)
		data[i] = (ALshort)(0xFFF * sin(phase += dph));
}

int main(int argc, char* argv[])
{
	ALshort data[BSIZE];
	ALuint Buffers[NUMBUFFERS];
	ALuint BufferID;
	ALuint Source;
	ALint processed;
	ALboolean finished = AL_FALSE;
	int i, j;

	AL_Init();

	AL_FORMAT_MONO16;
	alGenBuffers(NUMBUFFERS, Buffers);


	for(j = 0;j < NUMBUFFERS;j++)
	{
		fill_buffer(data, BSIZE);
		alBufferData(Buffers[j], AL_FORMAT_MONO16, data, 2 * BSIZE, 44100);
	}

	alGenSources(1, &Source);
	alSourceQueueBuffers(Source, NUMBUFFERS, Buffers);
	alSourcei(Source, AL_LOOPING, AL_FALSE);
	alSourcePlay(Source);

	while (!_kbhit())
	{
		alGetSourcei(Source, AL_BUFFERS_PROCESSED, &processed);
		if(!processed)
		{
			Sleep(10);
			continue;
		}
		while(processed)
		{
			alSourceUnqueueBuffers(Source, 1, &BufferID);
			fill_buffer(data, BSIZE);
			alBufferData(BufferID, AL_FORMAT_MONO16, data, 2 * BSIZE, 44100);
			alSourceQueueBuffers(Source, 1, &BufferID);
			processed--;
		}
	}

	alSourceStopv(1, &Source);
	alDeleteSources(1, &Source);
	alDeleteBuffers(NUMBUFFERS, Buffers);

	AL_Shutdown();
	return 0;
}


