program tgen;

{$APPTYPE CONSOLE}

uses
	Windows;

const
	AL_FORMAT_MONO16 = $1101;
	AL_FORMAT_STEREO16 = $1103;
	AL_BUFFERS_PROCESSED = $1016;
	AL_POSITION = $1004;
	AL_VELOCITY = $1006;
	AL_ORIENTATION = $100F;
	AL_LOOPING = $1007;

type
	ALfloat_p = ^single;
	ALint_p = ^longint;

function	alcOpenDevice(name : PChar):longint;stdcall;external 'OpenAL32.dll';
procedure	alcCloseDevice(device : longint);stdcall;external 'OpenAL32.dll';
function	alcCreateContext(device : longint;attrList : ALint_p):longint;stdcall;external 'OpenAL32.dll';
function	alcMakeContextCurrent(context : longint):longint;stdcall;external 'OpenAL32.dll';
function	alcGetCurrentContext:longint;stdcall;external 'OpenAL32.dll';
function	alcGetContextsDevice(context : longint):longint;stdcall;external 'OpenAL32.dll';
procedure	alcDestroyContext(context : longint);stdcall;external 'OpenAL32.dll';

procedure	alListenerfv(param : longint;values : ALfloat_p);stdcall;external 'OpenAL32.dll';
procedure	alGenBuffers(n : longint;buffers : ALint_p);stdcall;external 'OpenAL32.dll';
procedure	alDeleteBuffers(n : longint;buffers : ALint_p);stdcall;external 'OpenAL32.dll';
procedure	alBufferData(buffer,format : longint;data : pointer;size,freq : longint);stdcall;external 'OpenAL32.dll';
procedure	alGenSources(n : longint;sources : ALint_p);stdcall;external 'OpenAL32.dll';
procedure	alDeleteSources(n : longint;sources : ALint_p);stdcall;external 'OpenAL32.dll';
procedure	alSourcei(source,param,value : longint);stdcall;external 'OpenAL32.dll';
procedure	alGetSourcei(source,param : longint;value : ALint_p);stdcall;external 'OpenAL32.dll';
procedure	alSourcePlay(source : longint);stdcall;external 'OpenAL32.dll';
procedure	alSourceStop(source : longint);stdcall;external 'OpenAL32.dll';
procedure	alSourceQueueBuffers(source,n : longint;buffers : ALint_p);stdcall;external 'OpenAL32.dll';
procedure	alSourceUnqueueBuffers(source,n : longint;buffers : ALint_p);stdcall;external 'OpenAL32.dll';


const
	BSIZE	= 1024;
	NUMBUFFERS	= 8;
	OUTPUT_FREQ	= 44100;
	phase : single = 0;
	dph : single = (2 * 3.141592654 * 1000 / OUTPUT_FREQ);
	count : integer = 0;

var
	origin : array[0..2] of single = (0,0,0);
	listenerOri : array[0..5] of single = (0,0,-1,0,1,0);
	data : array [0..BSIZE-1] of smallint;
	Buffers : array [0..NUMBUFFERS-1] of longint;
	BufferID, Source, processed, i : integer;
	Context, Device : longint;

(*
procedure SetFreq(Freq : integer)
begin
	dph := 2 * 3.141592654 * Freq / OUTPUT_FREQ;
end;
*)

procedure fill_buffer;
var
	i : longint;
begin
	for i := 0 to BSIZE - 1 do
	begin
		data[i] := round($FFF * sin(phase));
		phase := phase + dph;
	end;
end;

begin
	Device := alcOpenDevice(nil);
	Context := alcCreateContext(Device,nil);
	alcMakeContextCurrent(Context);
	alListenerfv(AL_POSITION, @origin);
	alListenerfv(AL_VELOCITY, @origin);
	alListenerfv(AL_ORIENTATION, @listenerOri);
	alGenBuffers(NUMBUFFERS, @Buffers);

	for i := 0 to NUMBUFFERS-1 do
	begin
		fill_buffer;
		alBufferData(Buffers[i], AL_FORMAT_MONO16, @data, 2 * BSIZE, OUTPUT_FREQ);
	end;

	alGenSources(1, @Source);
	alSourceQueueBuffers(Source, NUMBUFFERS, @Buffers);
	alSourcei(Source, AL_LOOPING, 0);
	alSourcePlay(Source);

	while count < 200 do
	begin
		alGetSourcei(Source, AL_BUFFERS_PROCESSED, @processed);
		if processed = 0 then
		begin
			Windows.Sleep(10);
			continue;
		end;
		while processed >= 0 do
		begin
			alSourceUnqueueBuffers(Source, 1, @BufferID);
			fill_buffer;
			alBufferData(BufferID, AL_FORMAT_MONO16, @data, 2 * BSIZE, OUTPUT_FREQ);
			alSourceQueueBuffers(Source, 1, @BufferID);
			dec(processed);

      writeln(count);
      inc(count);

		end;
	end;
	alSourceStop(Source);
	alDeleteSources(1, @Source);
	alDeleteBuffers(NUMBUFFERS, @Buffers);
	alcMakeContextCurrent(0);
	alcDestroyContext(Context);
	alcCloseDevice(Device);
end.

